//+------------------------------------------------------------------+
//|                                              RndTradeRndExit.mq4 |
//|                                            Copyright  2008 Grib |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008 Grib"
#property link      ""
#include       <common.mqh>
#define NUM_BUY  20050611
#define NUM_SELL  20050612

int ticket;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

if(!OrderExist(NUM_SELL ,OP_SELL))Sell();
else 
   {
      CloseSell();
      updateMoneyManager();
      updateOrderManager();
   }

if(!OrderExist(NUM_BUY ,OP_BUY))Buy();
else 
   {
      CloseBuy();
      updateMoneyManager();
      updateOrderManager();
   }

}

//================ Buy =========================================================================================  
//

void Buy()
{ 
   double lot;
   int Ticket=0;
   MathSrand(GetTickCount());

   if(MathRand() > 16383.5)
    {
      RefreshRates();
      lot = lotsOptimized(Point);
      Ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,3,0,0,"TestDrawSell",NUM_BUY,0,Blue);
      if (ticket == -1) Alert("Buy position open");
    }//end if
}//end Buy


//
//================ Sell =========================================================================================  
//

void Sell()
{ 
   double lot;
   int Ticket=0;
   MathSrand(GetTickCount());

   if(MathRand() < 16383.5)
    {
      RefreshRates();
      lot = lotsOptimized(Point);
      Ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,3,0,0,"TestDrawBuy",NUM_SELL,0,Red);
      if (ticket == -1) Alert("Sell position open");
    }//end if
}//end Sell

   

//
//=============== Close Buys =========================================================================
//

void CloseBuy()
{
   int cnt,total=0,ticket=0,err=0,c=0;
   MathSrand(GetTickCount());

 if(MathRand() < 16383.5)
  {
     if (IsTradeAllowed())
      { 
         total = OrdersTotal();
         for(cnt=total-1;cnt>=0;cnt--)
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

            if (OrderSymbol() == Symbol() && OrderMagicNumber()==NUM_BUY && OrderType()==OP_BUY)
            {
               RefreshRates();
               OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Blue);
            }
         }
       }
    }      
}
          
//
//=============== Close Sells =========================================================================
//

void CloseSell()
{
   int cnt,total=0,ticket=0,err=0,c=0;
   MathSrand(GetTickCount());

 if(MathRand() > 16383.5)
  {
     if (IsTradeAllowed())
      { 
         total = OrdersTotal();
         for(cnt=total-1;cnt>=0;cnt--)
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

            if (OrderSymbol() == Symbol() && OrderMagicNumber()==NUM_SELL && OrderType()==OP_SELL)
            {
               RefreshRates();
               OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Blue);
            }
         }
       }
    }      
}   

bool OrderExist(int iMagic ,int iType)
{
   int cnt,total=OrdersTotal(),ticket=0,err=0,c=0;
     for(cnt=total-1;cnt>=0;cnt--)
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol() == Symbol() && OrderMagicNumber()==iMagic && OrderType()==iType)return(true);
      }
   return(false);
} 